package types

type Platform string

const (
	PlatformMezzanine Platform = "mezzanine"
	PlatformTmall2b   Platform = "tmall2b"
	PlatformTaobao    Platform = "taobao"
	PlatformPoizon2b  Platform = "poizon2b"
	PlatformOldPoizon Platform = "oldpoizon"
	PlatformJd        Platform = "jingdong"
	PlatformIm2b      Platform = "im2b"
	PlatformTmall2c   Platform = "tmall"
	PlatformB2B       Platform = "b2b"
	PlatformOpen      Platform = "open"
)

func (p Platform) GetName() string {
	switch p {
	case PlatformMezzanine:
		return "迷衣"
	case PlatformTmall2b:
		return "天猫ToB"
	case PlatformTaobao:
		return "淘宝"
	case PlatformPoizon2b:
		return "得物"
	case PlatformOldPoizon:
		return "旧得物"
	case PlatformJd:
		return "京东"
	case PlatformIm2b:
		return "ImToB"
	case PlatformTmall2c:
		return "天猫"
	case PlatformB2B:
		return "B2B"
	case PlatformOpen:
		return "开放平台"
	}
	return string(p)
}

func GetAllPlatforms() []Platform {
	return []Platform{
		PlatformMezzanine,
		PlatformTmall2b,
		PlatformTaobao,
		PlatformPoizon2b,
		PlatformJd,
		PlatformIm2b,
		PlatformTmall2c,
		PlatformB2B,
		PlatformOpen,
		PlatformOldPoizon,
	}
}

func IsPlatform(s string) bool {
	for _, p := range GetAllPlatforms() {
		if string(p) == s {
			return true
		}
	}
	return false
}
